Summary: This will your machine to use local dns caching 
Name: zz_local_dns_cache
Version: 1.0
Release: 4
License: GPL
Group: Fermi
URL: http://www.fnal.gov/cd/UNIX/linux/
Vendor: Fermilab
Packager: Troy Dawson
requires: caching-nameserver
requires: zz_dhcp_resolv
Source1: local.dns.cache
BuildRoot: %{_tmppath}/%{name}-%{version}
BuildArch: noarch

%description
Installing this package will 


%install
mkdir -p $RPM_BUILD_ROOT/etc/init.d/
cp -f %{SOURCE1} $RPM_BUILD_ROOT/etc/init.d/
chmod 755 $RPM_BUILD_ROOT/etc/init.d/*

%files
/etc/init.d/local.dns.cache

%post
/sbin/chkconfig --add local.dns.cache
/sbin/chkconfig --level 345 local.dns.cache on
#
# Put the right line in your resolv.conf file
#
if ! grep "127.0.0.1"  /etc/resolv.conf > /dev/null
then
	sed -e "/search/,/nameserver/s/nameserver*/& 127.0.0.1\nnameserver/" < /etc/resolv.conf > /etc/resolv.conf.new
	rm -f /etc/resolv.conf.old
	ln /etc/resolv.conf /etc/resolv.conf.old
	mv -f /etc/resolv.conf.new /etc/resolv.conf
fi

%postun
if [ "$1" = "0" ] ; then
	rm -f /etc/resolv.conf.old
	rm -f /etc/resolv.conf.new
	grep -v "nameserver 127.0.0.1" /etc/resolv.conf > /etc/resolv.conf.new
	ln /etc/resolv.conf /etc/resolv.conf.old
	mv -f /etc/resolv.conf.new /etc/resolv.conf
	perl -pe 's/listen-address=127.0.0.1/#listen-address=/g;' -i /etc/dnsmasq.conf
fi


%triggerin -- caching-nameserver
#
# Put's in the correct lines in the named.conf file
# 
ncfl="# dhcp updates here"

if [ -s /etc/named.conf ]; then
	ndns=`cat /etc/resolv.conf | grep nameserver | grep -v 127.0.0.1 | sed -e 's/nameserver *//g' | tr '\n' ';'`
	if grep "$ncfl"  /etc/named.conf > /dev/null
	then
		sed -e "s/forwarders.*$ncfl/forwarders {$ndns}; $ncfl/" < /etc/named.conf > /etc/named.conf.new
	else
		sed -e "s/^options {/&\n\tforwarders {$ndns}; $ncfl\n\tforward first;/" < /etc/named.conf > /etc/named.conf.new
	fi
	rm -f /etc/named.conf.old
	ln /etc/named.conf /etc/named.conf.old
	mv -f /etc/named.conf.new /etc/named.conf
	/etc/init.d/named condrestart
fi

%triggerin -- dnsmasq
#
# points the listen-addres to your localhost
# 
ncfl="# dhcp updates here"

if [ -s /etc/dnsmasq.conf ]; then
	perl -pe 's/#listen-address=/listen-address=127.0.0.1/g;' -i /etc/dnsmasq.conf
fi


%changelog
*Mon Dec 13 2010 Troy Dawson <dawson@fnal.gov> 1.0-4
- Added post commands to set linux-server to 127.0.0.1 in dnsmasq.conf

*Fri Jan 05 2007 Troy Dawson <dawson@fnal.gov> 1.0-2
- Added post and postun to add 127.0.0.1 to the resolv.conf

*Fri Jan 05 2007 Troy Dawson <dawson@fnal.gov> 1.0-1
- First pass, looks good


